// agena.h

#ifdef AGENA_DEBUG
#define DBG(x)  OutputDebugString(x);
#define DBG1(x, y)    \
{  TCHAR s[MAX_PATH]; wsprintf(s,x,y); OutputDebugString(s);  }
#else
#define DBG
#define DBG1
#endif

// defines

#define REGKEY_WINLOGON     \
  TEXT("Software\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon")
#define REGVALUE_GINADLL    TEXT("GinaDLL")

#define WELCOME_DLG         1000
#define WKSTALOCK_DLG       1100
#define SESSION_DLG         1200
#define LOGON_DLG           1300
#define UNLOCK_DLG          1400
#define ID_LOGOFF           1500
#define ID_LOCK             1501
#define ID_SHUTDOWN         1502
#define ID_RESTART          1503
#define ID_USERNAME         1504
#define ID_PASSWORD         1505
#define ID_DOMAIN           1506

// structs

typedef struct _AGENA_CONTEXT {
    PWLX_DISPATCH_VERSION_1_1  WlxFunctions;
    HANDLE hWlx;
    HANDLE hLSA;
    HANDLE hUserToken;
    PSID   pSid;
    LUID   AuthID;
    WCHAR  UserName[MAX_PATH];
    WCHAR  Password[MAX_PATH];
    WCHAR  Domain[MAX_PATH];
} AGENA_CONTEXT, *PAGENA_CONTEXT;

// prototypes

BOOL AgenaUninstall(void);
PWSTR AllocString(PWSTR);
BOOL AgenaLogonUser(PAGENA_CONTEXT);
int CALLBACK WelcomeDlgProc(HWND, UINT, WPARAM, LPARAM);
int CALLBACK SessionDlgProc(HWND, UINT, WPARAM, LPARAM);
int CALLBACK LogonDlgProc(HWND, UINT, WPARAM, LPARAM);
int CALLBACK UnlockDlgProc(HWND, UINT, WPARAM, LPARAM);

