#ifndef _CDriver_H_
#define _CDriver_H_

#include <winsvc.h>

// The following constants define the behavior in the
// destructor

#define	CDRIVER_KEEP_SCM_ENTRY_ALIVE	0x1
#define	CDRIVER_KEEP_DRIVER_ALIVE		0x2
#define	CDRIVER_KEEP_HANDLE_ALIVE		0x4


//============================================================
//		C D R I V E R     D E F I N I T I O N 
//============================================================

class CDriver {
	LPCTSTR		m_DriverName;
    SC_HANDLE   m_schSCManager;
	HANDLE		m_hDevice;
	DWORD		m_LastError;
	DWORD		m_Flags;	// see above

public:
	/***** C O N S T R U C T O R S *******/

	CDriver( LPCTSTR Drivername, DWORD dwFlags=0);
	~CDriver();

	/***** A C C E S S O R  S *******/

	// Zero indicates no error..otherwise congruent to Win32 Error Code
	DWORD	GetLastError() { return m_LastError; }
	// Returns handle to device (FileHandle)
	HANDLE	GetDeviceHandle() { return m_hDevice; }


	/***** M E T H O D S  *******/

	// Registers the Driver with the SCM
	BOOL Install(LPCTSTR ServiceExe, BOOL bAddPath = TRUE );
	// Starts the Driver Service
	BOOL Start();
	// Stops the Driver Service
	BOOL Stop();
	// Removes the Driver Service from the SCM database
	BOOL Remove();
	// Allows communication to the device
	BOOL OpenDevice( LPCSTR dosDeviceName=NULL );
	// Closes the handle to the device
	BOOL CloseDevice();
	// Thin wrapper around DeviceIoControl
	BOOL DeviceIoControl( DWORD dwIoControlCode, LPVOID lpInBuffer,
		DWORD nInBufferSize, LPVOID lpOutBuffer, DWORD nOutBufferSize,
		LPDWORD lpBytesReturned, LPOVERLAPPED lpOverlapped=0)
	{
		return ::DeviceIoControl( 
			m_hDevice, dwIoControlCode, lpInBuffer,
			nInBufferSize, lpOutBuffer, nOutBufferSize,
			lpBytesReturned, lpOverlapped);
	}

};

#endif