// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DbgTrap.h"

#include "MainFrm.h"
#include "DbgTrapView.h"
#include "JoseConst.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDM_CLEAR, OnClear)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_COMMAND(IDM_ONTOP, OnOntop)
	ON_UPDATE_COMMAND_UI(IDM_ONTOP, OnUpdateOntop)
	ON_COMMAND(IDM_CAPTUREKERNEL, OnCapturekernel)
	ON_UPDATE_COMMAND_UI(IDM_CAPTUREKERNEL, OnUpdateCapturekernel)
	ON_COMMAND(IDM_CAPTUREUSER, OnCaptureuser)
	ON_UPDATE_COMMAND_UI(IDM_CAPTUREUSER, OnUpdateCaptureuser)
	ON_COMMAND(IDM_AUTOSCROLL, OnAutoscroll)
	ON_UPDATE_COMMAND_UI(IDM_AUTOSCROLL, OnUpdateAutoscroll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	0						// Shameless plug
};



LONG
SetRegistryValue(
				 LPCTSTR pName,		// Substring relative to APP_REG_KEY to get data from
				 PVOID	 pBuffer,	// Buffer that the data is returned in
				 DWORD	 size,		// Size of the buffer...# of bytes written on return
				 DWORD	 type		// Type of the data to be stored
);

LONG
GetRegistryValue(
				 LPCTSTR pName,		// Substring relative to APP_REG_KEY to get data from
				 PVOID	 pBuffer,	// Buffer that the data is returned in
				 LPDWORD pSize		// Size of the buffer...# of bytes written on return
				 );


/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndStatusBar.SetPaneText( 1, JOSE_WEB_SITE, TRUE );

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	//
	// Restore the user's window settings
	//
	WINDOWPLACEMENT wpl;
	DWORD size = sizeof(wpl);

	LONG ret = GetRegistryValue(
				 _T("Win"),
				 (LPBYTE)&wpl,
				 &size
				 );

	if ( ret == ERROR_SUCCESS )
		SetWindowPlacement( &wpl );
	
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnClear() 
{
	DWORD ret = 0;

	CDbgTrapView* tv = (CDbgTrapView*)GetActiveFrame()->GetActiveView();

	tv->GetListCtrl().DeleteAllItems();

	tv->m_pdd->DeviceIoControl( IOCTL_RESET, 
							NULL,
							0,
							&tv->pInfo,
							sizeof(tv->pInfo),
							&ret
							);

	tv->prevIndex = 0;
	tv->count = 0;
	
}

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	
	//
	// Fix up our status bar to look right
	//

	if ( ::IsWindow(m_wndStatusBar.m_hWnd) )
	{
		m_wndStatusBar.SetPaneInfo( 0, ID_SEPARATOR, SBPS_STRETCH, 2*cx/3 );
		m_wndStatusBar.SetPaneInfo( 1, 0, SBPS_NORMAL, cx/3 );
	}
	
}

void CMainFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();
	
	WINDOWPLACEMENT wpl;
	GetWindowPlacement( &wpl );
	wpl.flags = WPF_SETMINPOSITION;

	LONG ret = SetRegistryValue(
			 _T("Win"),
			 (LPBYTE)&wpl,
			 sizeof(wpl),
			 REG_BINARY
			 );

	CDbgTrapDoc* pDoc = GetDoc();
	DWORD* poptions = &pDoc->m_optionFlags;

	ret = SetRegistryValue( _T("Options"), 
							(PBYTE)poptions, 
							sizeof(*poptions),
							REG_DWORD
							);
	
}

void CMainFrame::OnOntop() 
{
	CDbgTrapDoc* pDoc = (CDbgTrapDoc*)GetDoc();
	DWORD* poptions = &pDoc->m_optionFlags;
	if ( pDoc == NULL )
		return;

	if ( *poptions & OPTION_ONTOP )
	{
		const CWnd* t = &wndNoTopMost   ;
		SetWindowPos( t, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE );
		*poptions &= ~OPTION_ONTOP;
	}
	else
	{
		const CWnd* t = &wndTopMost   ;
		SetWindowPos( t, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE );
		*poptions |= OPTION_ONTOP;
	}
}

void CMainFrame::OnUpdateOntop(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck ( (GetDoc()->m_optionFlags & OPTION_ONTOP) == OPTION_ONTOP );	
}

void CMainFrame::OnCapturekernel() 
{
	BOOL	log;
	CDbgTrapDoc* pDoc = GetDoc();
	if ( pDoc == NULL )
		return;

	DWORD* poptions = &pDoc->m_optionFlags;


	if ( *poptions & OPTION_CAPTUREKERNEL )
	{
		*poptions &= ~OPTION_CAPTUREKERNEL;
		log = FALSE;
	}
	else
	{
		*poptions |= OPTION_CAPTUREKERNEL;
		log = TRUE;
	}

	CDbgTrapView* tv = (CDbgTrapView*)GetActiveFrame()->GetActiveView();
	DWORD ret = 0;
	tv->m_pdd->DeviceIoControl( IOCTL_LOGKERNEL, 
							&log,
							sizeof(log),
							NULL,
							0,
							&ret
							);

}

void CMainFrame::OnUpdateCapturekernel(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck ( (GetDoc()->m_optionFlags & OPTION_CAPTUREKERNEL) == OPTION_CAPTUREKERNEL );	
	
}

void CMainFrame::OnCaptureuser() 
{
	CDbgTrapDoc* pDoc = GetDoc();
	if ( pDoc == NULL )
		return;

	DWORD* poptions = &pDoc->m_optionFlags;
	BOOL	log;

	if ( *poptions & OPTION_CAPTUREUSER )
	{
		*poptions &= ~OPTION_CAPTUREUSER;
		log = FALSE;
	}
	else
	{
		*poptions |= OPTION_CAPTUREUSER;
		log = TRUE;
	}

	CDbgTrapView* tv = (CDbgTrapView*)GetActiveFrame()->GetActiveView();
	DWORD ret = 0;
	tv->m_pdd->DeviceIoControl( IOCTL_LOGUSER, 
							&log,
							sizeof(log),
							NULL,
							0,
							&ret
							);
}

void CMainFrame::OnUpdateCaptureuser(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck ( (GetDoc()->m_optionFlags & OPTION_CAPTUREUSER) == OPTION_CAPTUREUSER );	
	
}

CDbgTrapDoc* CMainFrame::GetDoc()
{
	return (CDbgTrapDoc*)GetActiveDocument();
}

void CMainFrame::OnAutoscroll() 
{
	CDbgTrapDoc* pDoc = GetDoc();
	if ( pDoc == NULL )
		return;

	DWORD* poptions = &pDoc->m_optionFlags;
	BOOL	log;

	if ( *poptions & OPTION_AUTOSCROLL )
	{
		*poptions &= ~OPTION_AUTOSCROLL;
		log = FALSE;
	}
	else
	{
		*poptions |= OPTION_AUTOSCROLL;
		log = TRUE;
	}
	
}

void CMainFrame::OnUpdateAutoscroll(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck ( (GetDoc()->m_optionFlags & OPTION_AUTOSCROLL) == OPTION_AUTOSCROLL );	
}
