///////////////////////////////////////////////////////////////////
// Demo.cpp - implementation file (not using MFC)
///////////////////////////////////////////////////////////////////
//
// Compiling Instructions:  
//        cl -DSTRICT demo.cpp logfile.cpp
//
// Running the application:
//        demo <level> <log filename>
//
// Example:
//        demo 4  c:\temp\log.txt

#include <stdio.h>
#include <windows.h>  // so Sleep() function can be used

#include "logfile.h"

CLogFile log;   // Global declaration of the CLogFile object

void Funct1( void );
void Funct2( void );

void main( int argc, char *argv[])
      {
      // the c:\logfiles directory must exist

      if (argc<3)
	{
	printf("Usage: %s <log level> <log file>\n",argv[0]);
	return;
	}

      long level=atoi(argv[1]);

      log.Start( argv[2],
           CLogFile::LOG_TO_EXPLICIT_PATH |CLogFile::LOG_TO_DEBUG,
           CLogFile::SHOW_ALL | CLogFile::INDENT_BY_LEVEL,
         level );

      log.LogMessage(1,"Application Started...");
      log.LogMessage(1,"Log File: %s",log.GetFilename());
      log.LogMessage(1,"Logging Level: %ld",log.GetLevel());
      Funct1();
      log.LogMessage(1,"Application Terminated...");
      }

void Funct1( void )
      {
      log.LogMessage(2,"Enter Funct1");
      Funct2();
      log.LogMessage(2,"Exit Funct1");
      }

void Funct2( void )
      {
      log.LogMessage(3,"Enter Funct2");

      int value;
      for (int i=0; i<5; i++)
            {
            value=i*2;

            // waste time
            Sleep(i*1000);       

            log.LogMessage(4, "Value: %ld",value);
            }

      log.LogMessage(3, "Exit Funct2");
      }
