// util.c

#define UNICODE
#define _UNICODE

#include <windows.h>
#include <winwlx.h>
#include <ntsecapi.h>
#include "agena.h"
 
HINSTANCE ghInst;

//-----------------------------------------------------------------
BOOL WINAPI DllMain(HINSTANCE hInst, DWORD dwReason, LPVOID rsv)
{
    switch (dwReason) {
        case DLL_PROCESS_ATTACH:
            ghInst = hInst;
        default:
            return TRUE;
    }
}
            
//-----------------------------------------------------------------
BOOL AgenaUninstall(void)
{
    HKEY hKey;

    DBG(TEXT("Agena!AgenaUninstall\n"));
    if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGKEY_WINLOGON, 0,
                     KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS) {
        return FALSE;
    }

    RegDeleteValue(hKey, REGVALUE_GINADLL);
    RegCloseKey(hKey);
    return TRUE;
}

//-----------------------------------------------------------------
PWSTR AllocString(PWSTR pszString)
{
    PWSTR   New;
    DWORD   bytes;

    if (pszString == NULL) {
        return NULL;
    }

    bytes = (wcslen(pszString) + 1) * sizeof(WCHAR);
    New = LocalAlloc(LMEM_FIXED, bytes);
    if (New) {
        wcscpy(New, pszString);
    }
    return New;
}

//-----------------------------------------------------------------
BOOL AgenaLogonUser(PAGENA_CONTEXT p)
{
    TOKEN_STATISTICS    tokenStats;
    TOKEN_GROUPS       *pGroups;
    DWORD               dwSize, i;
    BOOL                status = FALSE;

    DBG(TEXT("Agena!AgenaLogonUser enter\n"));

    if (LogonUser(p->UserName, p->Domain, p->Password,
                  LOGON32_LOGON_INTERACTIVE, 
                  LOGON32_PROVIDER_DEFAULT, &p->hUserToken)) {

        GetTokenInformation(p->hUserToken, TokenStatistics, 
                            &tokenStats,sizeof(tokenStats),&dwSize);

        pGroups = LocalAlloc(LMEM_FIXED, 2048);
        GetTokenInformation(p->hUserToken, TokenGroups, pGroups, 
                            2048, &dwSize);

        for (i = 0; i < pGroups->GroupCount; i++) {
            if ((pGroups->Groups[i].Attributes & 
                     SE_GROUP_LOGON_ID) == SE_GROUP_LOGON_ID) {
                CopySid(GetLengthSid(p->pSid), p->pSid,
                        pGroups->Groups[i].Sid );
                break;
            }
        }
        LocalFree(pGroups);
        p->AuthID = tokenStats.AuthenticationId;
        status = TRUE;
    }
    DBG(TEXT("Agena!AgenaLogonUser laeve\n"));
    return status;
}

